import request from '@/utils/request';
import type { ApiResult, PageResult } from '@/api';
import type { BookingUserEmergency, BookingUserEmergencyParam } from './model';
import { MODULES_API_URL } from '@/config/setting';

/**
 * 分页查询紧急联系人表
 */
export async function pageBookingUserEmergency(params: BookingUserEmergencyParam) {
  const res = await request.get<ApiResult<PageResult<BookingUserEmergency>>>(
    MODULES_API_URL + '/booking/booking-user-emergency/page',
    {
      params
    }
  );
  if (res.data.code === 0) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 查询紧急联系人表列表
 */
export async function listBookingUserEmergency(params?: BookingUserEmergencyParam) {
  const res = await request.get<ApiResult<BookingUserEmergency[]>>(
    MODULES_API_URL + '/booking/booking-user-emergency',
    {
      params
    }
  );
  if (res.data.code === 0 && res.data.data) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 添加紧急联系人表
 */
export async function addBookingUserEmergency(data: BookingUserEmergency) {
  const res = await request.post<ApiResult<unknown>>(
    MODULES_API_URL + '/booking/booking-user-emergency',
    data
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 修改紧急联系人表
 */
export async function updateBookingUserEmergency(data: BookingUserEmergency) {
  const res = await request.put<ApiResult<unknown>>(
    MODULES_API_URL + '/booking/booking-user-emergency',
    data
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 删除紧急联系人表
 */
export async function removeBookingUserEmergency(id?: number) {
  const res = await request.delete<ApiResult<unknown>>(
    MODULES_API_URL + '/booking/booking-user-emergency/' + id
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 批量删除紧急联系人表
 */
export async function removeBatchBookingUserEmergency(data: (number | undefined)[]) {
  const res = await request.delete<ApiResult<unknown>>(
    MODULES_API_URL + '/booking/booking-user-emergency/batch',
    {
      data
    }
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 根据id查询紧急联系人表
 */
export async function getBookingUserEmergency(id: number) {
  const res = await request.get<ApiResult<BookingUserEmergency>>(
    MODULES_API_URL + '/booking/booking-user-emergency/' + id
  );
  if (res.data.code === 0 && res.data.data) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}
